

function [A]=matrice(n)
h=1/n;
h2=h^2;
A =  diag([1;2/h2*ones(n-1,1);1]) - diag([0;1/h2*ones(n-1,1)],1) - diag([1/h2*ones(n-1,1);0],-1);
endfunction

function [A]=matrice_sparse(n)
//convention: the matrix has dimension n+1    
h=1/n;
h2=h^2;
ii=[(2:n),(2:n),(2:n),1,n+1]';
jj=[(2:n),(1:n-1),(3:n+1),  1,n+1]';
val=[2/h2*ones(n-1,1);-1/h2*ones(n-1,1);-1/h2*ones(n-1,1);1;1];    
A=sparse([ii,jj],val,[n+1,n+1]);
endfunction


function [b]=second_membre(f,n,T0,T1)
xs=linspace(0,1,n+1)';
b=[T0;f(xs(2:n));T1];
end


function x=jacobi(A,b,N)
   
np1=size(A,1);   
x=zeros(np1,1);   
D= diag(A); //[foo,D]=spget(D); //diagonal matrix 
E= -tril(A,-1); //lower-triangular part
F= -triu(A,1); //upper-triangular part   
for i=1:N
    x=(1./D).*(b + (E+F)*x);
end       
endfunction





